/* Dialog.h - all structs, prototypes, and constants used for the dialog boxes */

/* Version information for this .dll */
#define ZIPSHELLEXT_VER_MAJOR   0
#define ZIPSHELLEXT_VER_MINOR   1


typedef    struct    _ExtPair
{   char    Ext[8];
    int     Index;
    struct  _ExtPair    *Next;
}    ExtPair;

#define METHOD_LEN    7

typedef    struct    _ZIPEntry
{   DWORD       len;
#ifdef METHOD_LEN
    char        method[METHOD_LEN+1];
#else
    char        *method;
#endif
    DWORD       size;
    WORD        ratio;
    BYTE        day;
    BYTE        month;
    WORD        year;
    BYTE        hour;
    BYTE        min;
    DWORD       crc;
    char        *name;
    struct _ZIPEntry    *Next;
}    ZIPEntry;

typedef    struct    _ZIPMessage
{   char      *string;
    struct    _ZIPMessage    *Next;
}   ZIPMessage;

/*///////////////////////////////////////////////////////////////////////////
// ZIPShellDlg dialog */

/* Bit positions in ZIPShellDlgData.ColFlags */
#define    COL_SIZE     2
#define    COL_CSIZE    4
#define    COL_RATIO    8
#define    COL_DATE    16
#define    COL_TIME    32
#define    COL_CRC     64
#define    COL_METHOD 128

typedef struct  _ZIPShellDlgData
{/*    HICON        hIcon;*/
    HMENU        hPopupMenu;
    HIMAGELIST   hNormalImageList,hSmallImageList;

    ZIPMessage  *Messages;
    DCL         DCLBlock;
    ExtPair     *ExtList;
    ZIPEntry    *Entries;
    short       SubItem_Size,SubItem_CSize,SubItem_Ratio,SubItem_Date,SubItem_Time,SubItem_CRC,SubItem_Method,
                ColFlags;
}   ZIPShellDlgData;

/*///////////////////////////////////////////////////////////////////////////
// PasswdDlg dialog */

typedef struct  _PasswdDlgData
{   char    *p;
    int     n;
    char    *m;
    char    *name;
}   PasswdDlgData;

/*///////////////////////////////////////////////////////////////////////////
// ReplaceDlg dialog */
/*
typedef    struct
{   
}
*/
void SetListStyle(HWND hwndDlg,DWORD dwNewStyle);
void AdjColumns(HWND hwndDlg);
int  GetIconIndex(HWND,LPSTR);

void UncheckMenus(HWND hwndDlg);

#ifdef __cplusplus
extern "C"
{
#endif
BOOL APIENTRY PropDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam);
BOOL APIENTRY OptionsDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam);
BOOL APIENTRY ReplaceDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam);
BOOL APIENTRY CommentDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam);
BOOL APIENTRY PasswdDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam);
BOOL GetUnzipDll();
#ifdef __cplusplus
}
#endif
BOOL OnInitDialog(HWND hwndDlg,LPARAM lParam);
void OnPaint(HWND hwndDlg);
HCURSOR OnQueryDragIcon();
void OnShowWindow(HWND hwndDlg,BOOL bShow,UINT nStatus);
void OnGetdispinfoList(HWND hwndDlg,LV_DISPINFO *pDispInfo);
void OnStyle(HWND hwndDlg,LONG lStyle);
void OnOptions(HWND hwndDlg);
void OnViewComment(HWND hwndDlg);
void OnExtract(HWND hwndDlg);
void OnTest(HWND hwndDlg);

