/* PasswdDlg.c - File contains all regarding the GetPassword Dialog */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "..\unzip.h"
#include "..\crypt.h"
#include "unzip32dll.h"
#include "resource.h"
#include "Dialog.h"

HINSTANCE        g_hInst;
HINSTANCE        hUnzip32Dll;
_DLL_UNZIP        windll_unzip;
USERFUNCTIONS    UserFunctions;
ZIPMessage        *Messages;

BOOL APIENTRY PasswdDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{   PasswdDlgData   *pData;
    int             i;
    char            *format,*buffer;
    HWND            hWnd;

    switch(message)
    {   case    WM_INITDIALOG:
            SetWindowLong(hwndDlg,GWL_USERDATA,lParam);
            pData=(PasswdDlgData*)lParam;
            hWnd=GetDlgItem(hwndDlg,IDC_PASSWD_MESSAGE);
            /* determine how many storage is to be allocate */
            i=GetWindowTextLength(hWnd)+1;
            i+=strlen(pData->m)+1+strlen(pData->name)+1;
            /* allocate */
            format=(char*)malloc(i);
            /* read text from the control, the buffer for sprintf lies after 
                the format string */
            buffer=format+GetWindowText(hWnd,format,i)+1;
            /* take it as format string for sprintf */
            i=sprintf(buffer,format,pData->m,pData->name);
            /* and write it back to the control */
            SetWindowText(hWnd,buffer);

            /* and finally free */
            free(format);
        break;
/*        case    WM_CLOSE:
        break;*/
        case    WM_COMMAND:
            switch(LOWORD(wParam))
            {   case    IDOK:
                    pData=(PasswdDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
                    hWnd=GetDlgItem(hwndDlg,IDC_PASSWD);
                    GetWindowText(hWnd,pData->p,PWLEN);
                    EndDialog(hwndDlg,IZ_PW_ENTERED);
                break;
                case    IDCANCEL:
                    EndDialog(hwndDlg,IZ_PW_CANCEL);
                break;
                default:
                    return FALSE;
            }
        break;
        default:
            return FALSE;
    }
    return TRUE;
}


int WINAPI GetPasswd(char *p, int n, const char *m, const char * name)
{   int i;
    /* put all datas in one malloc */
    PasswdDlgData   *pData=(PasswdDlgData*)malloc(sizeof(PasswdDlgData)+strlen(m)+1+strlen(name)+1);

    pData->n=n;
    pData->m=(char*)pData+sizeof(*pData);
    strcpy(pData->m,m);
    pData->name=pData->m+strlen(m)+1;
    strcpy(pData->name,name);
//    pData->p=pData->name+strlen(name)+1;
    pData->p=p;
    i=DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_PASSWD),NULL,PasswdDlgProc,(long)pData);

    free(pData);
    return i;
}